"""
Django settings for sentinel project.

Generated by 'django-admin startproject' using Django 2.1.3.

For more information on this file, see
https://docs.djangoproject.com/en/2.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.1/ref/settings/
"""
import sentry_sdk
from sentry_sdk.integrations.django import DjangoIntegration
from pathlib import Path
from datetime import timedelta, datetime
from os.path import dirname, abspath, join
from dotenv import load_dotenv
from . import get_env_variable


env_path = Path('.') / '.env'
load_dotenv(dotenv_path=env_path)

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.1/howto/deployment/checklist/

BASE_DIR = dirname(dirname(dirname(abspath(__file__))))
BASE_DIR_LOG = join(dirname(BASE_DIR), 'logs')
SECRET_KEY = get_env_variable('SECRET_KEY')
DEBUG = False


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'rest_framework_jwt',
    'rest_framework_swagger',    
    'common',
    'utp',
    'celery',
    'corsheaders',
    'dynamic_preferences',
    'dynamic_preferences.users.apps.UserPreferencesConfig',
    'import_export',    
    'dashboard',  
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'simple_history.middleware.HistoryRequestMiddleware',
]

ROOT_URLCONF = 'config.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'config.wsgi.application'


# Database
# https://docs.djangoproject.com/en/2.1/ref/settings/#databases

# Password validation
# https://docs.djangoproject.com/en/2.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

LOGIN_URL = '/login/'
LOGIN_REDIRECT_URL = '/'

# Internationalization
# https://docs.djangoproject.com/en/2.1/topics/i18n/

LANGUAGE_CODE = 'en-us'

#TIME_ZONE = 'America/Santiago'

USE_I18N = True

USE_L10N = True

USE_TZ = False


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.1/howto/static-files/

STATIC_URL = '/static/'



REST_FRAMEWORK = {
    'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.AllowAny',#  IsAuthenticated
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_jwt.authentication.JSONWebTokenAuthentication',
    ),
    'DEFAULT_PAGINATION_CLASS': 'common.pagination.LinkHeaderPagination',
    'PAGE_SIZE': 100,
    'DEFAULT_THROTTLE_CLASSES': (
        'rest_framework.throttling.AnonRateThrottle',
        'rest_framework.throttling.UserRateThrottle'
    ),
    'NUM_PROXIES': 2,
    'DEFAULT_THROTTLE_RATES': {
        'anon': '100/hour',
        'user': '700/hour'
    },
    #token
    'JWT_EXPIRATION_DELTA': timedelta(hours=48),
    "JWT_ALLOW_REFRESH": True,

}


AUTHENTICATION_BACKENDS = (
    'common.backends.EmailAuthBackend',
    'django.contrib.auth.backends.ModelBackend'
)


SITE_NAME = "sentinel"
CSRF_COOKIE_NAME = 'csrftoken_' + SITE_NAME
SESSION_COOKIE_NAME = 'scn_' + SITE_NAME
NAME_JWT = 'tok_' + SITE_NAME

SWAGGER_SETTINGS = {
    'SECURITY_DEFINITIONS': {
        'api_key': {
            'type': 'apiKey',
            'in': 'header',
            'name': 'Authorization'
        }
    },
    'USE_SESSION_AUTH': False
}

ADMINS = [('Jovan', 'jovan.pacheco@optic.cl')]
MANAGERS = ADMINS
now_log = "{0.year}-{0.month}-{0.day}-{0.hour}".format(datetime.now()) 
LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'verbose': {
            'format': '%(levelname)-.3s %(asctime)s %(module)s %(name)s %(message)s \n\n'
        },
        'simple': {
            'format': '%(levelname)s %(message)s'
        },
    },
    'handlers': {
        'file': {
            'level': 'INFO',
            'class': 'logging.FileHandler',
            'formatter': 'verbose',
            #'filename': join(BASE_DIR_LOG, 'debug_django_%s.log' % str(now_log)),
            'filename': join(BASE_DIR_LOG, 'debug_django.log'),
        },
        'mail_admins': {
            'level': 'ERROR',
            'class': 'django.utils.log.AdminEmailHandler',
        },
        'console':{
            'level':'DEBUG',
            'class':'logging.StreamHandler',
            'formatter': 'simple'
        },
        # 'rotating' : {
        #     'level' : 'INFO',
        #     'class' : 'logging.handlers.RotatingFileHandler',
        #     'filename' : join(BASE_DIR_LOG, 'django_rotating.log'),
        #     'maxBytes' : 1024*1024*1, # 1MB
        #     'backupCount' : 10,
        #     'formatter' : 'verbose',
        # },        

    },
    'loggers': {
        'django.request': {
            'handlers': ['mail_admins', 'file','console'],
            'level': 'ERROR',
            'propagate': False,
        },
    },
}

DATA_UPLOAD_MAX_NUMBER_FIELDS = 10240

SENTINEL_VERSION = '0.3.1'


DYNAMIC_PREFERENCES = {

    # a python attribute that will be added to model instances with preferences
    # override this if the default collide with one of your models attributes/fields
    'MANAGER_ATTRIBUTE': 'preferences',

    # The python module in which registered preferences will be searched within each app
    'REGISTRY_MODULE': 'preferences',

    # Allow quick editing of preferences directly in admin list view
    # WARNING: enabling this feature can cause data corruption if multiple users
    # use the same list view at the same time, see https://code.djangoproject.com/ticket/11313
    'ADMIN_ENABLE_CHANGELIST_FORM': True,

    # Customize how you can access preferences from managers. The default is to
    # separate sections and keys with two underscores. This is probably not a settings you'll
    # want to change, but it's here just in case
    'SECTION_KEY_SEPARATOR': '__',

    # Use this to disable caching of preference. This can be useful to debug things
    'ENABLE_CACHE': True,

    # Use this to disable checking preferences names. This can be useful to debug things
    'VALIDATE_NAMES': True,
}

CORS_ORIGIN_WHITELIST = [
    "http://localhost:8000",
    "http://127.0.0.1:8000",
    "http://190.113.247.215",
    "http://190.113.247.219",
    "http://sentinel.devel7.cl",
    "https://sentinel.devel7.cl",
    "http://sentinel7.cl",
    "https://sentinel7.cl",    
]

sentry_sdk.init(
    dsn=get_env_variable('DSN'),
    integrations=[DjangoIntegration()]
)